SystemOrganization addCategory: #'PVpub-AnalogClockPrototype02'!

CircleMorph subclass: #Dial02
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PVpub-AnalogClockPrototype02'!

!Dial02 methodsFor: 'initialize-release' stamp: 'pv 12/1/2013 20:38'!
initialize
	| watchHand02 |
	super initialize.
	self extent: 200 @ 200;
		 position: 300 @ 300.
	watchHand02 :=  WatchHand02 new.
	watchHand02
		setInitialMidnightVerticesFromCenter: self center
		andRadius: self extent x / 2
		withFraction: 0.9.
	self addMorph: watchHand02.
	watchHand02 referencePosition: self center;
		 setRotationDegrees: 0! !

PolygonMorph subclass: #WatchHand02
	instanceVariableNames: 'rotationDegrees referencePositionLag'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PVpub-AnalogClockPrototype02'!

!WatchHand02 methodsFor: 'initialization' stamp: 'pv 9/22/2013 11:45'!
initialize
super initialize.
	referencePositionLag := 0 @ 0! !

!WatchHand02 methodsFor: 'initialization' stamp: 'pv 12/1/2013 20:43'!
setInitialMidnightVerticesFromCenter: aPoint andRadius: aFloat withFraction: aFractionFloat 
	| lozengeLengthFromCenter lozengeWidthFromCenter midnightVertices |
	lozengeLengthFromCenter := 3 max: (aFloat * aFractionFloat) rounded.
	lozengeWidthFromCenter := 1 max: (aFloat * (1.0 - aFractionFloat)) rounded.
	midnightVertices :=  Array
				with: aPoint + (0 @ lozengeWidthFromCenter)
				with: aPoint + (-1 * lozengeWidthFromCenter @ 0)
				with: aPoint + (0 @ -1 * lozengeLengthFromCenter)
				with: aPoint + (lozengeWidthFromCenter @ 0).
	self setVertices: midnightVertices.
	self rotationCenter: 0.5 @ (lozengeLengthFromCenter / (lozengeLengthFromCenter + lozengeWidthFromCenter))! !

!WatchHand02 methodsFor: 'access' stamp: 'pv 8/29/2013 21:31'!
setRotationDegrees: aFloat
	rotationDegrees := aFloat! !

!WatchHand02 methodsFor: 'stepping and presenter' stamp: 'pv 9/22/2013 12:46'!
step
	self
		assert: [referencePositionLag = (0 @ 0) | (self referencePosition = referencePositionLag)].
	rotationDegrees := rotationDegrees + 6 \\ 360.
	self rotationDegrees: rotationDegrees.
	referencePositionLag := self referencePosition! !
